/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdDedJikoku.cpp
// ****************************************************************
*/
#include "stdafx.h"

#ifndef _CONSOLE
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

#include "CdDedJikoku.h"

// ****************************************************************
//	CdDedJikoku
// ****************************************************************
const int iSecondsOfADay = 24 * 60 * 60 ;
unsigned int CdDedJikoku::m_iFmt = 0   ;

// --------------------------------
//@name ֐
// --------------------------------
int CdDedJikoku::adjustTotalSeconds( int iTotalSeconds ) 
{
	iTotalSeconds %= iSecondsOfADay ;
	if ( iTotalSeconds < 0 ){
		iTotalSeconds = iSecondsOfADay + iTotalSeconds ;
	}
	return ( iTotalSeconds ) ;
}

// ********************************
//	RXgN^
// ********************************
CdDedJikoku::CdDedJikoku() : 
		m_iTotalSeconds( -1 )
{
}

CdDedJikoku::CdDedJikoku( int iTotalSeconds ) 
{
	if ( iTotalSeconds < 0 ){
		iTotalSeconds = -1 ;
	}
	m_iTotalSeconds = adjustTotalSeconds( iTotalSeconds ) ;
}
	
CdDedJikoku::CdDedJikoku( int iHour , int iMinute , int iSecond ) 
{
	m_iTotalSeconds = adjustTotalSeconds( iHour * 60 * 60 + iMinute * 60 + iSecond ) ; 
}
CdDedJikoku::CdDedJikoku( const string& strTime ) 
	: m_iTotalSeconds( -1 ) 
{
	decode( strTime ) ;
}

// ********************************
//	CdDedJikoku
// ********************************
	// ********************************
	//@name 
	// ********************************
CdDedJikoku& CdDedJikoku::setTotalSeconds( int value ) 
{
	m_iTotalSeconds = adjustTotalSeconds( value ) ;
	return ( *this ) ;
}
	
CdDedJikoku& CdDedJikoku::setTime( int iHour , int iMinute , int iSecond ) 
{
	m_iTotalSeconds = adjustTotalSeconds( iHour * 60 * 60 + iMinute * 60 + iSecond ) ; 
	return ( *this ) ;
}
	
CdDedJikoku& CdDedJikoku::setNull() 
{
	m_iTotalSeconds = -1 ;
	return ( *this ) ;
}
	
	// ********************************
	//@name 
	// ********************************
int CdDedJikoku::compare( const CdDedJikoku& value )const 
{
	if ( m_iTotalSeconds > value.m_iTotalSeconds ){
		return ( 1 ) ;
	}	else if ( m_iTotalSeconds < value.m_iTotalSeconds ){
		return ( -1 ) ;
	}
	return ( 0 ) ;
}
	
CdDedJikoku& CdDedJikoku::addSeconds( int value ) 
{
	if ( !isNull() ){
		m_iTotalSeconds += value ;
		m_iTotalSeconds = adjustTotalSeconds( m_iTotalSeconds ) ;
	}
	return *this ;
}

int CdDedJikoku::subJikoku( const CdDedJikoku& value  )const 
{
	int iRv = 0 ; 
	if ( !isNull() && !value.isNull() ){
		iRv = m_iTotalSeconds - value.m_iTotalSeconds ;

		if ( iRv > 12*60*60 ){
			iRv -= 24*60*60 ;
		}	else if ( iRv < -12*60*60 ){
			iRv += 24*60*60 ;
		} 
	} 
	return ( iRv ) ;
}
	




int CdDedJikoku::subJikoku( const CdDedJikoku& value , 
		const CdDedJikoku& jikokuDateLine )const
{
	int iRv = 0 ; 
	if ( !isNull() && !value.isNull() ){
		iRv = m_iTotalSeconds - value.m_iTotalSeconds ;

		if ( !jikokuDateLine.isNull() && 
			m_iTotalSeconds < jikokuDateLine.m_iTotalSeconds &&  
			jikokuDateLine.m_iTotalSeconds <= value.m_iTotalSeconds ){
			//	tύXzĂ
			iRv += ( +iSecondsOfADay ) ;
		}
		if ( !jikokuDateLine.isNull() && 
			value.m_iTotalSeconds < jikokuDateLine.m_iTotalSeconds &&  
			jikokuDateLine.m_iTotalSeconds <= m_iTotalSeconds ){
			//	tύXzĂ
			iRv += ( -iSecondsOfADay ) ;
		}  
	} 
	return ( iRv ) ;
}
	
	
string CdDedJikoku::encode( unsigned int iFmt ) const
{
	string	strRv ;
	if ( !isNull() ){
		//	
		if ( ( iFmt & Format_HourZeroToNone ) == Format_HourZeroToNone ){
			char	szLs[16] ;
			sprintf( szLs , "%d" , getHour() ) ;
			strRv += szLs ;
		} else if ( ( iFmt & Format_HourZeroToSpace ) == Format_HourZeroToSpace ){
			char	szLs[16] ;
			sprintf( szLs , "%2d" , getHour() ) ;
			strRv += szLs ;
		}	else	{
			char	szLs[16] ;
			sprintf( szLs , "%02d" , getHour() ) ;
			strRv += szLs ;
		}
		//	̂̃R
		if ( ( iFmt & Format_NoColon ) == 0 ){
			strRv += ":" ;
		}
		//	
		{
			char	szLs[16] ;
			sprintf( szLs , "%02d" , getMinute() ) ;
			strRv += szLs ;
		}
		if ( ( iFmt & Format_NoSecond ) == 0 ){
			//	̂̃R
			if ( ( iFmt & Format_NoColon ) == 0 ){
				strRv += ":" ;
			}
			//	b
			{
				char	szLs[16] ;
				sprintf( szLs , "%02d" , getSecond() ) ;
				strRv += szLs ;
			}
		}
	}
	return ( strRv ) ;
}

int CdDedJikoku::decode( const string& value ) 
{
	int iRv = 0 ;

	string	strValue = value ;

	//	񂪋󕶎ȂAwNullԁxƂ܂B
	if ( value.empty() ){
		setNull() ;
		return ( 0 ) ;
	}

	//	RȂꍇ͒ǉ
	{
		string::size_type pos = strValue.find( ":" ) ;
		if ( pos == string::npos ){
			//	R܂B
			if ( strValue.size() > 2 ){
				strValue.insert( strValue.size() - 2 , ":" ) ; 
			}
			if ( strValue.size() > 5 ){
				strValue.insert( strValue.size() - 5 , ":" ) ; 
			}
		} 
	}
	//strValue = "13:15:45","9:15"
	
	//	bȂꍇ͒ǉ
	if ( strValue.size() <= 5 ){
		strValue += ":00" ;
	}
	//strValue = "13:15:45","9:15:00"

	//	10̈ʂȂꍇ͒ǉ
	if ( strValue.size() <= 7 ){
		strValue = string( "0" ) + strValue ;
	}
	//	10̈ʂXy[X̏ꍇ́AXy[X "0" ɕύX
	if ( strValue.size() > 0 && strValue[0] == ' ' ){
		strValue[0] = '0' ;
	}

	//strValue = "13:15:45","09:15:00"

	int iHour = -1 ;
	int iMinute = -1 ;
	int iSecond = -1 ;
	if ( strValue.size() == 8 ){
		//	
		{
			string	strLs = strValue.substr( 0 , 2 ) ;
			if ( strLs.find_first_not_of( "0123456789" ) == string::npos ){
				iHour = atoi( strLs.c_str() ) ;
			}
		}
		//	
		{
			string	strLs = strValue.substr( 3 , 2 ) ;
			if ( strLs.find_first_not_of( "0123456789" ) == string::npos ){
				iMinute = atoi( strLs.c_str() ) ;
			}
		}
		//	b
		{
			string	strLs = strValue.substr( 6 , 2 ) ;
			if ( strLs.find_first_not_of( "0123456789" ) == string::npos ){
				iSecond = atoi( strLs.c_str() ) ;
			}
		}
	}	else	{
		iRv = -1 ;	//	ڐsĂ܂B
		return ( iRv ) ;
	}
	
	if ( 0 <= iHour && iHour < 24 && 
			0 <= iMinute && iMinute < 60 && 
			0 <= iSecond && iSecond < 60 ){
		setTime( iHour , iMinute , iSecond ) ;
	}	else	{
		iRv = -2 ;	//	EEb̕\LsłB
	}
	
	return ( iRv ) ;
}

