/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: COuErrorInfo.cpp 10 2012-08-26 09:48:47Z okm $
// ****************************************************************
/** @file */
#include "str\OuPropertiesText\ErrorInfo\COuErrorInfo.h"
#include "str\strprintf.h"
#include "str\CdConnectedString2.h"
#include "Ou\dynamic_castOu.h"
#include "Ou\OuNew.h"

using namespace std ;
namespace OuPropertiesText{
namespace ErrorInfo{

	// ********************************
	//@name 萔
	// ********************************
const char* const COuErrorInfo::DirectoryName_ErrorInfo = "ErrorInfo" ;
const char* const COuErrorInfo::PropertyTextName_Reason = "Reason" ;
const char* const COuErrorInfo::DirectoryName_Prop = "Prop" ;

	// ********************************
	//@name 
	// ********************************
	
Ou<CDirectory> COuErrorInfo::toOuPropertiesTextErrorInfo()const
{
	int iRv =0 ;
	Ou<CDirectory> pCDirectory ;
	if ( iRv >= 0 )
	{
		pCDirectory = OuNew<CDirectory>( new CDirectory( DirectoryName_ErrorInfo ) ) ;
		CNodeContainer* pCNodeContainer = pCDirectory->getCNodeContainer() ; 
		pCNodeContainer->setValue( PropertyTextName_Reason , m_strReason ) ;
		if ( m_Prop.size() > 0 )
		{
			Ou<CDirectory> pdirProp = OuNew<CDirectory>( new CDirectory( DirectoryName_Prop ) ) ;
			*pdirProp->getCNodeContainer() = m_Prop ; 
			pCNodeContainer->insert( pdirProp ) ;
		}
	}

	return pCDirectory ;
}

int COuErrorInfo::fromOuPropertiesTextErrorInfo( 
		Ou<const CDirectory> pCDirectory )
{
	int iRv = 0 ;

	const IfNodeContainerConst* pCNodeContainer = pCDirectory->getIfNodeContainerConst() ;
	clear() ;

	string strReason ;
	CNodeContainer	aProp ;
	if ( iRv >= 0 )
	{
		if ( pCDirectory->getName() != DirectoryName_ErrorInfo )
		{
			iRv = -1 ;	//	pCDirectory  "Directory" ł͂܂B
		}
	}
	if ( iRv >= 0 )
	{
		strReason = pCNodeContainer->getValue( PropertyTextName_Reason ) ;
		if ( strReason.empty() )
		{
			iRv = -2 ;	//	Directory "Reason" PropertyText ܂B
		}
	}
	if ( iRv >= 0 )
	{
		if ( pCNodeContainer->sizeInName( DirectoryName_Prop ) > 0 ) 
		{
			Ou<const CDirectory> pdirProp = dynamic_castOu<const CDirectory>( 
				pCNodeContainer->getInName( DirectoryName_Prop , 0 ) 
			);
			if ( pdirProp != NULL )
			{
				aProp = *Ou<CDirectory>( pdirProp->clone() )->getCNodeContainer() ;
			}
		}
	}
	if ( iRv >= 0 )
	{
		m_strReason = strReason ;
		m_Prop = aProp ;
	}
	return iRv ;
}

std::string COuErrorInfo::toOuErrorInfoText()const 
{
	string strRv ;

	//Reason
	strRv = m_strReason ;

	//Prop
	for ( int idxProp = 0 ; idxProp < m_Prop.size() ; idxProp ++ )
	{
		Ou<CNode>	pCNode = m_Prop.get( idxProp ) ;
		Ou<CPropertyString> pCPropertyString = dynamic_castOu<CPropertyString>( pCNode ) ;
		if ( pCPropertyString != NULL && !pCPropertyString->getName().empty() )
		{
			strRv += '\t' ;
			strRv += pCPropertyString->getName() ;
			if ( !pCPropertyString->getValue().empty() )
			{
				strRv += '=' ;
				strRv += pCPropertyString->getValue() ;
			}
		}
	}
	return strRv ;
}

int COuErrorInfo::fromOuErrorInfoText( 
	const std::string& strOuErrorInfoText ) 
{
	int iRv = 0 ;
	clear() ;
	string strReason ;
	CNodeContainer	aProp ;

	CdConnectedString2 aCdConnectedString2( 
		strOuErrorInfoText , '\t' , '=' ) ;

	//Reason
	if ( iRv >= 0 )
	{
		if ( aCdConnectedString2.size() > 0 )
		{
			CdConnectedString2::CdItem aCdItem = aCdConnectedString2.at( 0 ) ;
			
			strReason = aCdItem.getName() ;
			if ( !aCdItem.getValue().empty() )
			{
				strReason += aCdConnectedString2.getEqualChar() ;
				strReason += aCdItem.getValue() ;
			}
		}
	}

	//Prop
	for ( int idxProp = 1 ; iRv >= 0 && idxProp < aCdConnectedString2.size() ; idxProp ++ )
	{
		CdConnectedString2::CdItem aCdItem = aCdConnectedString2.at( idxProp ) ;
		Ou<CPropertyString> pCPropertyString = OuNew<CPropertyString>( 
			new CPropertyString( aCdItem.getName() , aCdItem.getValue() ) ) ;
		aProp.insert( pCPropertyString ) ;
	}


	if ( iRv >= 0 )
	{
		m_strReason = strReason ;
		m_Prop = aProp ;
	}
	return iRv ;
}

void COuErrorInfo::clear() 
{
	m_strReason.erase() ;
	m_Prop.erase( 0 , INT_MAX ) ;
}

bool COuErrorInfo::isNull()const 
{
	return ( m_strReason.empty() && m_Prop.size() == 0 ) ;
}

} //namespace OuPropertiesText{
} //namespace ErrorInfo{
