/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	LogMsg.cpp
// ****************************************************************
*/

#include <time.h>
#include <stdio.h>
#include <string.h>

#ifdef  LOGMSG_MILLISEC
#include <sys/types.h>
#include <sys/timeb.h>
#ifdef   _MSC_VER
#define	ftime	_ftime
#define	timeb	_timeb
#endif /*_MSC_VER*/
#endif /*LOGMSG_MILLISEC*/


#ifdef  LOGMSG_BYTELIMIT
#include <sys/types.h> 
#include <sys/stat.h> 
#ifdef   _MSC_VER
#define	stat	_stat
#else  /*_MSC_VER*/
#include <unistd.h> 
#endif  /*_MSC_VER*/
#endif /*LOGMSG_BYTELIMIT*/


#include "LogMsg.h"

static char g_szLogFilename[256] = "logMsg.log" ;

/**
 * 	݂̃O̕WxłB
 * 	ftHg͂OłB
 * 	logmsg_setLogLevel() ŁAύXł܂B
 */
static int  g_iLogLevel = 0 ;

/**
 * 	݂̃O̍sł
 * 	logmsg_LogMsgStr() ֐́A
 *  Oǉ閈ɁA̒lXV܂B
 */
static int	g_iLogCount = 0 ;

/**
 * 	O̍ősB
 * 	LogMsg()  LogMsgL() ́A
 *  O̍s̒lɒBĂA
 * 	Ot@Cɂ܂B
 */
static int g_iLogCountLimit = 5000 ;

void logmsg_setFilename( const char* lpszLogFilename )
{
	strncpy( g_szLogFilename , lpszLogFilename , 
		sizeof(g_szLogFilename) / sizeof(g_szLogFilename[0]) ) ;
	g_szLogFilename
		[ sizeof(g_szLogFilename) / sizeof(g_szLogFilename[0]) - 1 ] = '\0' ;
}

void logmsg_setLogLevel( int ev )
{
	g_iLogLevel = ev ;
}

int logmsg_getLogLevel()
{
	return ( g_iLogLevel ) ;
}
void logmsg_setLogCountLimit( int ev ) 
{
	g_iLogCountLimit = ev ;
}
int logmsg_getLogCountLimit() 
{
	return ( g_iLogCountLimit ) ;
}


void logmsg_LogMsgV( int iLevel , const char* fmt , va_list	marker ) 
{
	if ( iLevel <= g_iLogLevel ){
		if ( g_iLogCount >= g_iLogCountLimit ){
			//	s g_iLogCountLimit ɒBĂA̓e
			//	j܂B
			FILE*	pFile = fopen( g_szLogFilename , "wt" ) ;
		
			if ( pFile != NULL ){
				fclose( pFile ) ;
				g_iLogCount = 0 ;
			}
		}
#ifdef  LOGMSG_BYTELIMIT
		{
			struct stat	aStat ;
			if ( stat( g_szLogFilename , &aStat ) == 0 ){
				if ( aStat.st_size >= g_iLogCountLimit * 80 ){
					//	TCYwős~80xoCgɒBĂꍇA
					//	̓ej܂B
					FILE*	pFile = fopen( g_szLogFilename , "wt" ) ;
		
					if ( pFile != NULL ){
						fclose( pFile ) ;
						g_iLogCount = 0 ;
					}
				}
			}
		}
#endif /*LOGMSG_BYTELIMIT*/
		{
			//	Ot@Cɒǉ܂B
	
			FILE*	pFile = fopen( g_szLogFilename , "a+" ) ;
			if ( pFile != NULL ){
#ifdef  LOGMSG_MILLISEC
				struct timeb aTimeb ;
				ftime( &aTimeb ) ;
				struct tm Localtime = *localtime( &aTimeb.time );
				fprintf( pFile , "[%02d:%02d:%02d]" , 
							Localtime.tm_hour , 
							Localtime.tm_min ,
							Localtime.tm_sec ) ; 
				fprintf( pFile , "[%03d]" , 
							aTimeb.millitm ) ;
#else /*LOGMSG_MILLISEC*/
				time_t	aTime = time( NULL ) ;
				struct tm Localtime = *localtime( &aTime );
				fprintf( pFile , "[%02d:%02d:%02d]" , 
							Localtime.tm_hour , 
							Localtime.tm_min ,
							Localtime.tm_sec ) ;
#endif /*LOGMSG_MILLISEC*/
				vfprintf( pFile , fmt , marker ) ;
				fputc( '\n' , pFile ) ; 
				fclose( pFile ) ;
				g_iLogCount ++ ;
			}
		}
	}
	
}

void logmsg_LogMsgL( int iLevel , const char* fmt , ... ) 
{
	va_list	marker ;	
	va_start( marker, fmt );   
	logmsg_LogMsgV(  iLevel ,  fmt , marker )  ;
}

void logmsg_LogMsg( const char* fmt , ... ) 
{
	va_list	marker ;	
	va_start( marker, fmt );   
	logmsg_LogMsgV( 2 ,  fmt , marker )  ;
}

